CLSALL:
 CLS
CLSGRAPH:
 RECT ZERO,ZERO,XLIMIT,YLIMIT,ZERO:RETURN

HIDEALL:
  GOSUB HIDEGRAPHICS:GOTO HIDETEXT
SHOWALL:
  GOSUB SHOWGRAPHICS:GOTO SHOWTEXT

HIDEGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER0.OFF:RETURN

SHOWGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER0.ON:RETURN

HIDETEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER1.OFF:RETURN

SHOWTEXT:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER1.ON:RETURN

TEXTBOX:
  LOCATE Y,X:PRINT CHR$(DChars%(1));RPT$(DChars%(2),W-2);CHR$(DChars%(3));
  IF H=2 THEN SKIPMID
  BStart=Y+1:BEnd=Y+(H-2)
  FOR Y2 = BStart TO BEnd:LOCATE Y2,X:PRINT CHR$(DChars%(4));RPT$(32,W-2);CHR$(DChars%(5));:NEXT
SKIPMID:
  LOCATE Y+H-1,X:PRINT CHR$(DChars%(6));RPT$(DChars%(7),W-2);CHR$(DChars%(8));:RETURN

LoadDChars:
  RESTORE PETSCIIDRAW
  FOR I=1 TO 8
   READ DChars%(I)
  Next
  RETURN

PETSCIIDRAW:
 DATA $CF,$B7,$D0,$B4,$AA,$CC,$EF,$BA


FILEEXISTS:
  FF$=F$:FE%=0:FF$=FF$+",S,R"
  OPEN 2,DEVICE,2,FF$:CLOSE 2
  GOSUB GETFILECODE
  FE%=(FCode<=20):RETURN

DOS.CMD:
 OPEN 15,DEVICE,15, DOS$
 GOTO GETFCODE

GETFILECODE:
  OPEN 15,8,15
GETFCODE:
  INPUT#15,FCode,FC$,A,B:CLOSE 15:RETURN

FIXCURSOR:
  FBASE=$9F*8+$F000
  FOR X=0 TO 6:VPOKE 1,FBASE+X,0:NEXT X
  VPOKE 1,FBASE+7,$FF

GetParamString:
 OldBank=PEEK(0)
 BANK 0
 ADDR=$BF00
 PARAM.STRING$=""
 FOR I = 0 TO 1 STEP 0
     C=PEEK(ADDR)
     IF C>0 THEN ADDR=ADDR+1
     PARAM.STRING$=PARAM.STRING$+CHR$(C)
     IF C=0 THEN I=1
 NEXT
 BANK OldBank:RETURN

PUTPARAMMSG:
   PARAM.STRING$=ZSM.MSG$

PutParamString:
  OldBank=PEEK(0)
  BANK 0
  ADDR=$BF00
  IF LEN(PARAM.STRING$)=0 THEN SKIPPUT
  FOR I=1 TO LEN(PARAM.STRING$)
    POKE ADDR, ASC(MID$(PARAM.STRING$,I))
    ADDR=ADDR+1
  NEXT
  POKE ADDR, 0
  RETURN

ClearParamBuffer:
   OB=PEEK(0):BANK 0
   FOR ADDR = $BF00 TO $BFFF:POKE ADDR, 0:NEXT
   BANK OB:RETURN

Setup.Banked.Ram:
  POKE C.REG,1
  SYS MEM.TOP
  NUM.BANKS = PEEK(A.REG)
  IF NUM.BANKS=0 THEN NUM.BANKS=256
  HI.Bank=NUM.BANKS-1
  LO.Bank = 2
  Scratch.BANK = HI.Bank
  HI.Bank = HI.Bank - 1
  FREE.Banks = (HI.Bank-LO.Bank) + 1
  RETURN

ERRORHALT:
  COLOR 1,0
  PRINT
  COLOR 10,0
  PRINT "FATAL ERROR: ";
  COLOR 13,0
  PRINT ERR$;"{CR}{CR}"
  COLOR 1,0:END



